
#    Note:  This is loaded into the namespace  POWER

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    foreach port {1 2 3 4} {variable p6$port; set p6$port 0}


   proc  show_variables {} {

      set rc [catch {exec curl --url http://localhost:8015/R3B/COMMS/COMMS.tml?Action=PowerOff   &} m]
      InsertLog "localhost returned: rc=$rc; $m"

#       GetPower
#       foreach port {1 2 3 4} {variable p6$port; InsertLog "p6$port = [set p6$port]"}
   }

   proc SetPower {port state} {

      set rc [catch {exec curl --url IP9258/set.cmd?user=admin+pass=12345678+cmd=setpower+p6$port=$state} m1]
#  InsertLog "SetPower returned: rc=$rc; $m1"
      if {$rc != 1} {
          InsertLog "SetPower returned: rc=$rc; $m1"
      }

   }

   proc GetPower {} {

      set rc [catch {exec curl --url IP9258/set.cmd?user=admin+pass=12345678+cmd=getpower} m1]
#  InsertLog "GetPower returned: rc=$rc; $m1"
      if {$rc != 1} {
         InsertLog "GetPower returned: rc=$rc; $m1"
      } else {
         set m [string range [string range $m1 6 end] 0 22]
         foreach item [split $m ,] {
            set p [first [split $item =]]
            set vl [second [split $item =]]
            variable $p
            set $p $vl
         }
      }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   SETPOWER {SetPower [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        GetPower
     }

}   ;# end of if {$started == 0}




