

#    Note:  This is loaded into the namespace  CALIB

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable HelpTopic "R3B"

    variable allmodules 0

    for {set i 0} {$i <= 26} {incr i} {variable Opt800.$i 0}

    
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

  proc  show_variables {} {
      global NumSide
      global ModID0 ModID1
      global NumASICSperSIDE
      global SIDEList
      global ASICList0 ASICList1
      global SIDE
      global ASIC


       for {set i 0} {$i <= 26} {incr i} {variable Opt800.$i; set Opt8000.$i 0}
       do_redisplay

       for {set i 0} {$i <= 26} {incr i} {variable Opt800.$i; InsertLog "800.$i = [set Opt800.$i]"}

   }

   proc do_redisplay {} {
     variable Opt800.0

     set Opt800.0 [ReadR3BRegister 0x200]
     WriteR3BRegister 0x200 [expr ([set Opt800.0] & 0x00ffffff) | 0xff000000]
     WriteR3BRegister 0x200 [set Opt800.0]

     for {set i 0} {$i <= 26} {incr i} {
        variable Opt800.$i
        set Opt800.$i [ReadR3BRegister [expr 0x200 + $i]]
     }
   }

   proc do_setOpt800 {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K
          WriteR3BRegister [expr 0x200 + $i] $vl;  InsertLog "Write 0x200 + $i $vl"
      }

      selectmodule $BAK   ;#  restore
   }

   proc do_Calibrate {} {
       global SIDEList
       global ASICList0 ASICList1
       variable allmodules

       InsertLog "starting calibrate"

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          foreach side $SIDEList {
            foreach asic [set ASICList$side] {

              set i 5    ;#  REG5
              set REG5.$side.$asic [ReadR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i]]   ;#  save current value
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] 0   ;# disable data output from asic

            }
          }
   
       run_calibration   ;#   see also in sys.tcl

          foreach side $SIDEList {
            foreach asic [set ASICList$side] {

              set i 5    ;#  REG5
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] [set REG5.$side.$asic]   ;#  restore setting

            }
          }
          
      }

      selectmodule $BAK   ;#  restore

       InsertLog "finished calibrate"
   }

   proc run_calibration {} {
      variable Opt800.1

       InsertLog "running calibrate"

       set BAK [ReadR3BRegister 0x200]

       WriteR3BRegister 0x200 0x00ff0000   ;#  soft reset active
        after 100
       WriteR3BRegister 0x200 0x00000000   ;#  soft reset inactive
        after 100

       WriteR3BRegister 0x200 0x000000ff   ;#  DataIn select start
        after 100

        set Opt800.1 [ReadR3BRegister 0x201]   ;#  status 

       WriteR3BRegister 0x200 0x00000000   ;#  DataIn select stop

        InsertLog "Calibration complete for $::R3B::R3B4K: Align Done Status = [set Opt800.1]"

         set p1 [expr ([set Opt800.1] & 255)]
         set p2 [expr (([set Opt800.1] >> 8) & 255)]

         if {[expr ($p1 ^ $p2)] != 255} {
             InsertLog "Calibration failed"
         } else {
             InsertLog "Calibration OK"
         }

       WriteR3BRegister 0x200 $BAK

       InsertLog "end of calibrate"
   }

   proc do_expert {cmd} {

       switch $cmd {

          RUNCALIB {do_Calibrate}
          default {}
       }
   }
   
    proc  do_click {}  {
	variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable HelpTopic

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   
                   HELP     {
                       switch $vl {
                          0  {set HelpTopic "Hardware"}
                          1  {set HelpTopic "Select"}
                          2  {set HelpTopic "Setup"}
                          3  {set HelpTopic "Screens"}
                          4  {set HelpTopic "Offsets"}
                          5  {set HelpTopic "Introduction"}
                          6  {set HelpTopic "Calibration"}
                          default {set HelpTopic "R3B"}
                       }
                       do_help
                   }
		   
                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
		   
                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
		   
                   OPTS800     {do_setOpt800 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}

                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
	  }
        }
        do_redisplay
     }
     do_redisplay
    
}   ;# end of if {$started == 0}
