


   proc selectmodule {vl} {
       global ModID0
       global ModID1

#puts "selectmodule #1 $vl R3B4K = $::R3B::R3B4K"

       if {$ModID0 == 255 || $ModID1 == 255} {puts "ModID require initialise"} else {
           if {$::R3B::R3B4K == $vl} {return}
           if {$vl == "undefined"} {return}
       }

       set ::R3B::R3B4K $vl      ;#   select required module

       set m [ReadR3BRegister 0x002]   ;#  should contain the ModID info

#puts "selectmodule #3 $vl $m "

       if {$m == 0x0000 || $m == 0xffff} {

#         the ModID FPGA register has never been set (or set to default)

          set rc [load_configuration]

       } else {

          set f [expr $m & 0x3e]
          set z [read_config $f]                 ;#   obtain the ASIC hardware configuration
       }

#puts "selectmodule #4  $ModID0  $ModID1"

       WriteR3BRegister 0x002 [expr ($ModID1 << 8) | $ModID0]

  }

   proc load_configuration {} {

#        InsertLog "module currently selected is [set ::R3B::R3B4K]"
#    search for a suitable ASIC to get ModID0 from 

    set testdata 0x5a

    foreach ASIC {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} {
      foreach SIDE {0 1} {

        set i 0
        set z [catch {WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $testdata} m]
        if {$z == 0} {
            set z [catch {ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]} m]
            set vl [expr $m & 255]
            set rc [catch {WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] 0} m]
            if {$z == 0} {
                if {$vl == $testdata} {   ;# this ASIC seems to be working!!
                   set i 6                ;# the ASIC register containing the ModID
                   set z [catch {ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]} m]
                   if {$z == 0} {
                      set f [expr $m & 0x3e]
                      set z [read_config $f]                 ;#    aim to obtain the ASIC hardware configuration 
                      if {$z == 0} {
                          InsertLog "Obtained R3B hardware configuration file using ID $f from SIDE $SIDE ASIC $ASIC"
                          return 
                      }
                   }
                }
            }
        }
      
      }
    }

        set z [read_config default]
        if {$z == 0} {
              InsertLog "Obtained R3B hardware configuration file using default"
              return
        }

        InsertLog "failed to obtain any R3B configuration file: $m"
        InsertLog "this MUST be fixed before you continue"
        
   }

   proc do_ASICReset {} {

       WriteR3BRegister 0x304 2000
       WriteR3BRegister 0x300 0x10   ;#  reset to load values
       WriteR3BRegister 0x300 0

#       WriteR3BRegister 0x303 1
#       WriteR3BRegister 0x300 0x14   ;#  reset to load values
#       WriteR3BRegister 0x300 0

       WriteR3BRegister 0x300 8
       WriteR3BRegister 0x300 0      ;#  generate reset pulse
   }

   proc read_config {f} {
       global env

       set z [catch {source [file join $env(MIDASBASE) R3B config $f]} m]
       InsertLog "using config file [file join $env(MIDASBASE) R3B config $f]"
#puts "using config file [file join $env(MIDASBASE) R3B config $f]"
       if {$z != 0} {
           InsertLog "failed to read R3B config file: $m"
           set z [catch {source [file join $env(MIDASBASE) R3B config default]} m]
           InsertLog "using config file [file join $env(MIDASBASE) R3B config default]"
           if {$z != 0} {
               InsertLog "failed to read default R3B config file: $m"
           }
       }
       return 0
   }


