# Note:  This is loaded in the namespace
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {  ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_testSamplingPoint { params } { 
       global SIDEList
       global ASICList0 ASICLIST1
	
	# It powers up 8 non-adjacent channels each time.
	
	variable msgIden
	
	# set name [lindex [lindex $params 1] 0]
	set sideUnderTest [lindex [lindex $params 1] 1]
	set asicUnderTest [lindex [lindex $params 1] 2]
	
	do_getState 
	# Start DAQ.
	after 500 set timeout 1
	do_go
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 1 } {return "Daq not started properly.";}
	
	
	# Loop over individual side.
	foreach itrSide [set SIDEList]  {
	    
	    if {$itrSide != $sideUnderTest} {continue;}
	    
	    # Loop over individual asic.
	    foreach itrAsic [set ASICList$itrSide]  {
		
		if {$asicUnderTest != "all" && $asicUnderTest != $itrAsic } {continue;}
		
		# Enable test pulse injection
		set_asicValidate $itrSide $itrAsic 1
		
		## ==
		# TO BE REMOVED
		foreach itrPkTm {0 7 15} { ;#[*0.5us+0.5us]
		    foreach itrPlsAmp {1 48 96} { ;#[DN]
			foreach itrPrd {20000 40000 60000} { ;#[10ns] 
			    ## ==
			    
			    ## ==
			    # TO BE RESTORED
			    ## Set file name
			    #set fileName  /MIDAS/SpecData/R3B/TestData/
			    #append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
			    #append fileName "TestSamplingPoint-"
			    #append fileName "Side$itrSide-Asic$itrAsic.txt"
			    ## ==
			    
			    ## ==
			    # TO BE REMOVED
			    # Set file name
			    set fileName  /MIDAS/SpecData/R3B/TestData/
			    append fileName [clock format [clock seconds] -format "%Y-%m-%d-"]
			    append fileName "TestSamplingPoint-"
			    append fileName "Side$itrSide-Asic$itrAsic-PkTm$itrPkTm-PlsAmp$itrPlsAmp-Prd$itrPrd.txt"
			    ## ==
			    
			    # Create file and set permissions.
			    set flagOpen [catch {open $fileName w} fileInput]
			    set flagPerm [catch {file attributes $fileName -permissions rwxrwxrwx} ]
			    if { $flagOpen != 0 } { InsertLog "Cannot open $fileName." }
			    if { $flagPerm != 0 } { InsertLog "Error setting permission of $fileName." }
			    
			    # Flush file header.
			    puts $fileInput "$itrSide $itrAsic $itrPkTm $itrPlsAmp $itrPrd"
			    flush $fileInput
			    
			    # Set pulse amplitude.
			    set valueVcalh [expr 64+$itrPlsAmp] ;# [DN]
			    set valueVcall 64 ;# [DN]
			    set registerVcalh 16
			    set registerVcall 17
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcalh] $valueVcalh
			    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerVcall] $valueVcall
			    
			    # Loop over individual channels.
			    set channelNumber 128
			    set channelGroup 4
			    for {set itrGroup 0} {$itrGroup < $channelNumber/$channelGroup} {incr itrGroup} {
				
				# To run on subset of channel.
				# if {$itrGroup != 0 } { continue;}
				
				# Power on channels
				for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				    set valuePlsInj [expr int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
				    set registerPlsInj [expr int ( 64 + ($dummyChannel/8) )]
				    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPlsInj] $valuePlsInj
				    
				    set valuePwr [expr 255 - int( pow (2,  $dummyChannel - ( $dummyChannel/8)*8 ) ) ]
				    set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
				    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] $valuePwr
				}
				after 500
				
				# Loop over sampling point
				for {set itrSpPt 0} {$itrSpPt < 16} {incr itrSpPt} {
				    
				    # Set pulse params
				    set pulseNumber   512;# [a.u.]
				    set pulseWidth    [expr ($itrSpPt+0.5)*100];# [10ns]
				    set pulseDelay    [expr $itrPrd - $pulseWidth];# [10ns]
				    do_loadPulseParams $pulseWidth $pulseDelay $pulseNumber
				    
				    # Set register PkTm and SpPt
				    # 4MSB = PkTm, 4LSB = Sample.
				    set valuePkTm $itrPkTm;# [*0.5us+0.5us]
				    set valuePkTmAndSpPt  [expr ($valuePkTm << 4) | $itrSpPt];
				    set registerPkTmAndSpPt 4 ;
				    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPkTmAndSpPt] $valuePkTmAndSpPt
				    
				    # Inject pulses 
				    do_testPulse $pulseWidth $pulseDelay $pulseNumber
				    
				    # Zero histograms. 
				    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
					set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
					set fileName "E.$itrSide.$itrAsic.$dummyChannel"
					# Empty the content of the histogram 
					# Check also that the histogram has been created.
					if { [ZeroSpectrum $fileName] != 0 } { 
					    return "Histograms E.$itrSide.$itrAsic.* were not created";}
				    }
				    do_testPulse $pulseWidth $pulseDelay $pulseNumber
				    
				    for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
					set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
					set plot  [do_analyseSpectra $itrSide $itrAsic $dummyChannel]
					set range [lindex $plot 0]
					set data  [lindex $plot 1]
					puts $fileInput "$dummyChannel $itrSpPt $range"
					puts $fileInput $data
					flush $fileInput
				    }
				    
				} ;# end loop over sampling point
				
				# Power off channel.
				for {set itrChannel 0} {$itrChannel < $channelGroup} {incr itrChannel} {
				    set dummyChannel [expr $itrGroup + ($itrChannel* ($channelNumber/$channelGroup) ) ]
				    set registerPwr [expr int ( 80 + ($dummyChannel/8) )]
				    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
				    
				    set registerPlsInj [expr int ( 64 + ($dummyChannel/8) )]
				    WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPlsInj] 0
				    
				}
			    } ;# end of loop over channel.
			    
			    close $fileInput
			
			} ;#end of for each on itrPrd	
		    } ;#end of for each on itrDelay	
		} ;#end of for each on itrPkTm	
		
		# Disable test pulse injection
		set_asicValidate $itrSide $itrAsic 0 
		
	    } ;# end of loop over asic.
	} ;#end of loop over side.
	
	# Stop DAQ
	do_getState
	after 500 set timeout 1
	do_stop
	vwait timeout
	# Mandatory to enquire state
	if { [do_getState] != 0 } {return "Daq did not stop correctly";}
	
	return "Test completed"
	
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	# InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    INITIALIZE_ASICS  { InsertLog "[do_powerOffFrontEnd]";}
		    INITIALIZE_DAQ    { InsertLog "[do_initializeDaq $cgidata]"}
		    RESET    { set started 0; }
		    TEST_SAMPLINGPOINT { InsertLog "[do_testSamplingPoint $cgidata]" }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}
