# TODO :
# - put everything in a namespace.
# - clean code.
# - initialize ASICs should automatically initialize all the avaialble asics.

#namespace eval Cmn {
    
variable msgIden "Detector test:"

# This takes care of initializatiation.
proc do_initializeDaq { params } {
    
    variable msgIden
    
    after 5000 set timeout 1
    do_reset
    vwait timeout
    # Mandatory to enquire state
    if { [do_getState] != 2} { puts "$msgIden problem with do_reset" ; return "Error"
    } else {puts "$msgIden do_reset is OK, state [do_getState]"} 
    
    # Select on which side to enable histograms
    set side    [lindex [lindex $params 1] 1]
    set hitBit [lindex [lindex $params 1] 2]
    after 1000 set timeout 1
    do_histogramSettings $side "E" 4096 0 0 $hitBit
    vwait timeout
    
    after 5000 set timeout 1
    do_enableHistogramming
    vwait timeout
    # Mandatory to enquire state
    if { [do_getState] != 2} { puts "$msgIden problem with do_enableHistogramming" ; 
	return "Error"
    } else {puts "$msgIden do_enableHistogramming is OK, state [do_getState]"} 
    
    after 90000 set timeout 1
    do_setup 
    vwait timeout
    # Mandatory to enquire state
    if { [do_getState] != 0} { puts "$msgIden problem with do_setup" ; return "Error"
    } else {puts "$msgIden do_setup is OK, state [do_getState]"} 
    
    after 1000 set timeout 1
    do_setDMABuffer
    vwait timeout
    
    return "Daq initialized"
    
}

proc do_initializeDaq1 { params } {
    
    variable msgIden
    
    after 5000 set timeout 1
    do_reset
    vwait timeout
    # Mandatory to enquire state
    if { [do_getState] != 2} { puts "$msgIden problem with do_reset" ; return "Error"
    } else {puts "$msgIden do_reset is OK, state [do_getState]"} 
    
    # Select on which side to enable histograms
    set side [lindex [lindex $params 1] 1]
    after 1000 set timeout 1
    do_histogramSettings $side "E" 4096 0 0 1
    vwait timeout
    
    after 5000 set timeout 1
    do_enableHistogramming
    vwait timeout
    # Mandatory to enquire state
    if { [do_getState] != 2} { puts "$msgIden problem with do_enableHistogramming" ; 
	return "Error"
    } else {puts "$msgIden do_enableHistogramming is OK, state [do_getState]"} 
    
    after 90000 set timeout 1
    do_setup 
    vwait timeout
    # Mandatory to enquire state
    if { [do_getState] != 0} { puts "$msgIden problem with do_setup" ; return "Error"
    } else {puts "$msgIden do_setup is OK, state [do_getState]"} 
    
    after 1000 set timeout 1
    do_setDMABuffer
    vwait timeout
    
    return "Daq initialized (type1)"
    
}

proc do_powerOffFrontEnd {} {
    
    foreach itrSide [set ::R3B::[set ::R3B::R3B4K].SIDEList]  {
	foreach itrAsic [set ::R3B::[set ::R3B::R3B4K].ASICList$itrSide]  {
	    
	    # Loop over channels.
	    set channelNumber 128
	    for {set itrChannel 0} {$itrChannel < $channelNumber} {set itrChannel [expr $itrChannel+8]} {
		set registerPwr [expr 80 + ($itrChannel/8)]
		WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
	    } ;# end for itrChannel
	    
	} ;# end foreach itrAsic
    } ;# end foreach itrSide
    
    return "Front end powered off"
    
}

proc do_enableCalibration {} {
    
    foreach itrSide [set ::R3B::[set ::R3B::R3B4K].SIDEList]  {
	foreach itrAsic [set ::R3B::[set ::R3B::R3B4K].ASICList$itrSide]  {
	    
	    # Loop over channels.
	    set channelNumber 128
	    for {set itrChannel 0} {$itrChannel < $channelNumber} {set itrChannel [expr $itrChannel+8]} {
		
		set registerCal [expr 64 + ($itrChannel/8)]
		WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerCal] 255
		
		set registerPwr [expr 80 + ($itrChannel/8)]
		WriteR3BASICRegister [expr ($itrSide << 18) + ($itrAsic << 10) + $registerPwr] 255
	    } ;# end for itrChannel
	    
	} ;# end foreach itrAsic
    } ;# end foreach itrSide
    
    return "Calibration enabled"
    
}

# This enables the histogramming.
proc do_enableHistogramming {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqSetOption "HistEnable=1"
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption "$AcqSetOption"} m]
    } else {;}
    
}

# This sets the burst size and 
# the buffer size for the DMA.
proc do_setDMABuffer {} {
    
    variable serverName $::R3B::R3B4K
    variable burstSize 64
    variable blockSize 1
    
    WriteR3BRegister [expr 0x100 + 3] $burstSize
    WriteR3BRegister [expr 0x100 + 4] $blockSize
}

# This starts the data acquisition.
proc do_go {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    set server_name $::DataAcquisition::ACQSERVER
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoGo "$AcqParameter"} m]
    } else {;}
    
}

# This stops the data acquisition.
proc do_stop {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    set server_name $::DataAcquisition::ACQSERVER
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoStop "$AcqParameter"} m]
    } else { InsertLog "ERROR: not possible to start data acquistion on $server_name"}
    
}

proc do_reset {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoReset "$AcqParameter"} m]
    } else {;}
    
}

proc do_setup {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    variable AcqParameter "None"
    
    if { [info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	 $MIDAS_DataAcquisitionControlServer_Exists == 1} then {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoSetUp "$AcqParameter"} m]
    } else {;}
    
}

# Check the status of the DAQ: 
#    code (int)  state (string)
#       0           stopped
#       1           going
#       2           reset
#       3           setting up
#       4           changing to going
#       5           changing to stopped
#       6           error   
#       7           changing to reset
#       8           undefined 
#       9           executing 

proc do_getState {} {
    
    global MIDAS_DataAcquisitionControlServer_Exists
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && 
	$MIDAS_DataAcquisitionControlServer_Exists == 1} {
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
    } else {;}
    
    if {$rc != 0} {
	set rc -1
    } else {
	set rc [lindex $m 1]
    }
    return $rc
}

proc do_loadPulseParams {pulseWidth pulseDelay pulseNumber} {
    
    # This function should be merged in do_testPulse
    # At the moment code 4 (rst) causes problems with pulse injection.
    
    # Stop any injection of pulses.
    WriteR3BRegister 0x300 0
    
    # Set registers:
    # reg 1 - p_width
    # reg 2 - p_delay
    # reg 3 - p_number
    WriteR3BRegister [expr 0x300 + 1] $pulseWidth
    WriteR3BRegister [expr 0x300 + 2] $pulseDelay
    WriteR3BRegister [expr 0x300 + 3] $pulseNumber
    
    # Load new values. 
    WriteR3BRegister 0x300 4 
    WriteR3BRegister 0x300 0
    
}

# This controls the pulse injection.
proc do_testPulse {pulseWidth pulseDelay pulseNumber} {
    
    # Stop any injection of pulses.
    WriteR3BRegister 0x300 0
    
    # Start the injection of pulses.
    WriteR3BRegister 0x300 3
    
    # It will wait twice the time required for pulse injection.
    set clockPeriod 10e-9 ;# [s]
    set timeTotal [expr ($pulseWidth + $pulseDelay)*$pulseNumber*$clockPeriod];# [s]
    set timeTotal [expr round($timeTotal*1e3*2) +1];# [ms] 
    after $timeTotal;# [ms]
    
}

proc do_analyseSpectra { side asic channel } {
    
    set fileName "E.$side.$asic.$channel"
    # puts "$fileName"
    
    # set SpecNames [SpectrumNames]
    # SpectrumNames is a function of Html/RunControl/sys.tcl 
    # I do not understand how it can be called here.
    # In fact I do not have any include of Html/RunControl/sys.tcl.
    
    set SpecDetails [SpectrumDetails $fileName]
    # SpecDetails has lenght 6.
    # The third element is the range : [0, x-max].
    set range [lindex $SpecDetails 2]
    set data [SpectrumRead1D $fileName 0 $range]
    # puts "Range $range , $data"
    
    # This should zero the histogram.
    ZeroSpectrum $fileName
    
    return [list $range $data] 
}

proc set_asicValidate { side asic n} {
	
    set vl [ReadR3BASICRegister [expr ($side << 18) + ($asic << 10) + 1]] ;#  REG1
    set vl [expr ($vl & 0xc0) + ($n << 4)]
    WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + 1] $vl
    
}

proc do_histogramSettings { side type channels offset shift hitBit} {
    
    # Dummy variables for side selection.
    variable isSide0 0;
    variable isSide1 0;
    if { $side==0 } {
	set isSide0 1
	set isSide1 0
    } elseif { $side==1 } {
	set isSide0 0
	set isSide1 1
    }
    
    # Dummy variables for type selection.
    variable isE  0;
    variable isDt 0;
    if { $type == "E" } {
	set isE  1
	set isDt 0
    } elseif { $type == "Dt" } {
	set isE  0
	set isDt 1
    }
    
    # Dummy variables for hit bit selection.
    variable isHit01 0;
    variable isHit0  0;
    variable isHit1  0;
    if { $hitBit == "doNotCare" } {
	set isHit01 1
	set isHit0  0
	set isHit1  0
    } elseif { $hitBit == 0 } {
	set isHit01 0
	set isHit0  1
	set isHit1  0
    } elseif { $hitBit == 1 } {
	set isHit01 0
	set isHit0  0
	set isHit1  1
    }
    
    # Set options 
    foreach itrOption [lsort [array names ::Options] ] {
	
	# Always set these to 1
	if { $itrOption == "Include.R3B" } {
	    set ::Options($itrOption) 1
	} elseif { $itrOption == "R3B_GroupBase" } {
	    set ::Options($itrOption) 1
	}
	
	# DT spectra
	if { $itrOption == "R3B.DTchannels"} {
	    set ::Options($itrOption) [expr $channels*$isDt]
	} elseif { $itrOption == "R3B.DToffset"} {
	    set ::Options($itrOption) [expr $offset*$isDt]
	} elseif { $itrOption == "R3B.DTshift"} {
	    set ::Options($itrOption) [expr $shift*$isDt]
	} elseif { $itrOption == "R3B_Hist_DT_Enable" } {
	    set ::Options($itrOption) $isDt
	}
	
	# Energy spectra
	if { $itrOption == "R3B.channels"} {
	    set ::Options($itrOption) [expr $channels*$isE]
	} elseif { $itrOption == "R3B.offset"} {
	    set ::Options($itrOption) [expr $offset*$isE]
	} elseif { $itrOption == "R3B.shift"} {
	    set ::Options($itrOption) [expr $shift*$isE]
	} elseif { $itrOption == "R3B_Hist_E_Enable" } {
	    set ::Options($itrOption) $isE
	} elseif { $itrOption == "R3B_Hist_Hit01_Enable" } {
	    set ::Options($itrOption) $isHit01
	} elseif { $itrOption == "R3B_Hist_Hit0_Enable" } {
	    set ::Options($itrOption) $isHit0
	} elseif { $itrOption == "R3B_Hist_Hit1_Enable" } {
	    set ::Options($itrOption) $isHit1
	}
	
	# Enable for side 0 (N side)
	if { [string match "R3B_Hist_0.*" $itrOption] } { 
	    set ::Options($itrOption) $isSide0
	}
	
	# Enable for side 1 (P side)
	if { [string match "R3B_Hist_1.*" $itrOption] } { 
	    set ::Options($itrOption) $isSide1
	}
    } ;# end of foreach itrOption 
    
#    SaveOptions  // put in comment by Marc
    
}

#} ;# end of namespace
