
#    Note:  This is loaded into the namespace  EASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable HelpTopic "R3B"

    variable PAGEList {- 0 1 2 3}
    variable PAGE [first $PAGEList]

    variable allmodules 0
    variable allasics 0
    variable allsides 0
    variable allcals 0
    variable allpowers 0
    variable allpageregs 0

    variable filelist {undefined}
    variable filename [first $filelist]
    
    for {set i 0} {$i <= 9} {incr i} {
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }

    for {set i 10} {$i <= 21} {incr i} {
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }

    for {set i 64} {$i <= 95} {incr i} {
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }

    for {set i 128} {$i <= 255} {incr i} {   ;#   page n
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }
    
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc  show_variables {} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIDE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC

       variable allmodules
       variable allasics
       variable allpowers
       variable allcals
       variable allpageregs

          InsertLog "module = $::R3B::R3B4K"

          InsertLog "NumSide = $NumSide"
          InsertLog "NumASICSperSIDE = $NumASICSperSIDE"
          InsertLog "SIDEs = $SIDEList"
          InsertLog "ASICs 0 = $ASICList0"
          InsertLog "ASICs 1 = $ASICList1"

          InsertLog "SIDE = $SIDE; ASIC = $ASIC"
          InsertLog "ModID 0 = $ModID0;  ModID 1 = $ModID1"

       InsertLog "all modules = $allmodules; all asics = $allasics; all cals = $allcals; all powers = $allpowers; all page regs = $allpageregs"
   }
    
    proc get_scripts {} {
        variable filelist
        variable filename
        global tcl_platform
        
        if {$tcl_platform(platform) == "windows"} {set filename "undefined"; return}

        set arg "-name \"*tcl\""
        set z [catch {eval exec find Scripts $arg} m]

        if {$z != 0} {
            InsertLog "Unable to obtain script files: $m"
            return
        }

        set filelist {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend filelist $item
        }

        if {[llength $filelist] == 0} {set filename "undefined"} else {set filename [first $filelist]}

   }

   proc do_redisplay {} {
     global SIDE ASIC
     variable PAGE

     if {$PAGE == "-"} {

        for {set i 0} {$i <= 7} {incr i} {
           variable Reg.Value$i
           set z [catch {ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]} m]
           if {$z != 0} {puts "do_redisplay:SIDE $SIDE; ASIC $ASIC; Read register $i returned $m"}
           set Reg.Value$i $m
# puts "Reg.Value$i =  [set Reg.Value$i]"
        }

        for {set i 10} {$i <= 23} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
# puts "Reg.Value$i =  [set Reg.Value$i] "
        }

        for {set i 64} {$i <= 95} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
# puts "Reg.Value$i =  [set Reg.Value$i] "
       }

     } else {

	 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + 0]  [expr 1 << $PAGE]

        for {set i 128} {$i <= 255} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + $i]]
        }
     }
   }

   proc do_setReg {i vl} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC

      variable PAGE
      variable allmodules
      variable allasics
      variable allsides
      variable allcals
      variable allpowers
      variable allpageregs

     set ABAK $ASIC
     set SBAK $SIDE

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

     foreach SIDE $SIDEList {
        if {$allsides == 0 && $SIDE != $SBAK} continue
     
     foreach ASIC [set ASICList$SIDE] {
        if {$allasics == 0 && $ASIC != $ABAK} continue

          if {$PAGE == "-"} {
                 set done 0
                 if {$i >= 64 && $i < 80 && $allcals == 1} {
                     for {set j 64} {$j < 80} {incr j} {
                         WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $j] $vl
                         variable Reg.Value$j; set Reg.Value$j $vl
                     }
                     set done 1
                 }
                 if {$i >= 80 && $i < 96 && $allpowers == 1} {
                     for {set j 80} {$j < 96} {incr j} {
                         WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $j] $vl
                         variable Reg.Value$j; set Reg.Value$j $vl
                     }
                     set done 1
                 }
                 if {$done == 0} {
                     WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl
                     variable Reg.Value$i; set Reg.Value$i $vl
                 }
          }
          if {$PAGE != "-"} {
                 set done 0
                 if {$allpageregs == 1} {
	             WriteR3BASICRegister  [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + 0] [expr 1 << $PAGE]
                     variable Reg.Value0; set Reg.Value0 [expr 1 << $PAGE]
                     for {set j 128} {$j < 256} {incr j} {
                         WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + $j] $vl
                         variable Reg.Value$j; set Reg.Value$j $vl
                     }
                     set done 1
                 }
                 if {$done == 0} {
	            WriteR3BASICRegister  [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + 0] [expr 1 << $PAGE]
                    variable Reg.Value0; set Reg.Value0 [expr 1 << $PAGE]
                    WriteR3BASICRegister  [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + $i] $vl
                    variable Reg.Value$i; set Reg.Value$i $vl
                 }
          }
      }
      }

     }

     selectmodule $BAK   ;#  restore
     set ASIC $ABAK
     set SIDE $SBAK

      if {$allasics != 0} {do_redisplay}
   }

   proc do_CallAll {vl} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC

      variable allmodules
      variable allasics
      variable allsides

     set ABAK $ASIC
     set SBAK $SIDE

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          foreach SIDE $SIDEList {
              if {$allsides == 0 && $SIDE != $SBAK} continue

          foreach ASIC [set ASICList$SIDE] {
              if {$allasics == 0 && $ASIC != $ABAK} continue

              for {set i 64} {$i <= 79} {incr i} {
                 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl
              }
          }
          }

      }

      selectmodule $BAK   ;# restore

      set ASIC $ABAK
      set SIDE $SBAK
   }

   proc do_PowerAll {vl} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC

      variable allmodules
      variable allasics
      variable allsides

     set ABAK $ASIC
     set SBAK $SIDE

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          foreach SIDE $SIDEList {
              if {$allsides == 0 && $SIDE != $SBAK} continue

          foreach ASIC [set ASICList$SIDE] {
              if {$allasics == 0 && $ASIC != $ABAK} continue

              for {set i 80} {$i <= 95} {incr i} {
                 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl
              }
          }
          }
      }

      selectmodule $BAK

      set ASIC $ABAK
      set SIDE $SBAK
   }


   proc do_SetCalAll {} {do_CallAll 0xff; do_redisplay}

   proc do_UnSetCalAll {} {do_CallAll 0x00; do_redisplay}

   proc do_SetPowerDnAll {} {do_PowerAll 0xff; do_redisplay}

   proc do_UnSetPowerDnAll {} {do_PowerAll 0x00; do_redisplay}


   proc do_expert {cmd} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          switch $cmd {
              do_Initialise  {source [file join Scripts Initialise.tcl]}
              default {$cmd}
          }

      }

      selectmodule $BAK
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable HelpTopic

      variable allasics
      variable allcals
      variable allpowers
      variable allpageregs

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {get_scripts; do_redisplay}
                   VARIABLES {show_variables}
                   
                   HELP     {
                       switch $vl {
                          0  {set HelpTopic "Hardware"}
                          1  {set HelpTopic "Select"}
                          2  {set HelpTopic "EASIC"}
                          3  {set HelpTopic "Screens"}
                          4  {set HelpTopic "Offsets"}
                          5  {set HelpTopic "Introduction"}
                          6  {set HelpTopic "Calibration"}
                          7  {set HelpTopic "ASIC"}
                          default {set HelpTopic "R3B"}
                       }
                       do_help
                   }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl; do_redisplay}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLASICS   {variable allasics; set allasics [expr ($allasics + 1) & 1]}
                   ALLSIDES   {variable allsides; set allsides [expr ($allsides + 1) & 1]}
                   ALLCALS    {variable allcals; set allcals [expr ($allcals + 1) & 1]}
                   ALLPOWERS  {variable allpowers; set allpowers [expr ($allpowers + 1) & 1]}
                   ALLPAGE    {variable allpageregs; set allpageregs [expr ($allpageregs + 1) & 1]}

                   PAGE     {variable PAGE; set PAGE $vl; do_redisplay}
                   ASIC     {global ASIC; set ASIC $vl; do_redisplay}
                   SIDE     {global SIDE; set SIDE $vl; do_redisplay}
                   SCRIPT   {variable filename; set filename $vl}
                   RUNSCRIPT {variable filename; source $filename}

                   REG     {do_setReg [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]; set allasics 0}
                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
       #        do_redisplay
     }

     do_redisplay
     get_scripts

}   ;# end of if {$started == 0}




