
#    Note:  This is loaded into the namespace  R3B_Diagnostics

#variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable testing 0
    variable running 0

    variable AddrSpaceList
    variable OffsetList
    variable SlaveLIst

    variable AddrSpace
    variable Address
    variable Offset
    variable Slave
    variable SData
    variable GData


    set AddrSpaceList [list \
         "/dev/i2c/0" \
         "/dev/i2c/1" \
    ]

    set OffsetList [list \
       "0x00"  \
       "0x04"  \
    ]

    set SlaveList [list \
       "0x80"  \
       "0x90"  \
    ]

    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set Slave 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable Slave
        variable SData
        variable GData
        variable testing
        variable running

#        global XR3BAccessServerHost XR3BAccessServerPort
#        global XR3BASICAccessServerHost XR3BASICAccessServerPort

        InsertLog "R3B4K = $::R3B::R3B4K"
        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Slave=$Slave; Offset=$Offset; SetData=$SData; GetData=$GData"
#       InsertLog "XR3BAccessServerHost=$XR3BAccessServerHost; XR3BAccessServerPort=$XR3BAccessServerPort"
#        InsertLog "XR3BASICAccessServerHost=$XR3BASICAccessServerHost; XR3BASICAccessServerPort=$XR3BASICAccessServerPort"

        InsertLog "$Address  $Offset  returns [ReadR3BRegister [expr ($Address + $Offset) >> 2]]"
        InsertLog "testing = $testing"
        InsertLog "running = $running"
        InsertLog "[namespace current]"

       InsertLog "TestMode = $::R3B::TestMode"
   }

   proc starttest {} {
       variable testing
       variable running
       
       set testing 1
       set running 0

   InsertLog "$testing $running"

       after 100  {
#          set z [catch {::namespace inscope ::urn:R3B_Diagnostics runtest} m]
           set z [catch {::R3B_Diagnostics::runtest} m]
           InsertLog "$z $m"
       }
   }

   proc runtest {} {
       variable testing
       variable running 

       set running 1
 
       for {set i 0} {$i < 1000} {incr i} {
           if {$testing == 0} {set running 0;return}
           incr testing
           after 5000
       }
   }

   proc do_expert {cmd p} {
       variable testing

       switch $cmd {

          Run_Test {
             switch $p {
               0  {InsertLog "starting test"; starttest}
               1  {InsertLog "ending test"; set testing 0}
             }
          }

          default {}
       }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable Slave
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {WriteR3BRegister [expr ($Address>>2) + ($Offset>>2)] $SData}
                GET      {set GData [ReadR3BRegister [expr ($Address>>2) + ($Offset>>2)]]}
                SETGET   {
                    WriteR3BRegister [expr ($Address>>2) + ($Offset>>2)] $SData
                    set GData [ReadR3BRegister [expr ($Address>>2) + ($Offset>>2)]]
                }

                ADDRSPACE  {
                    set Address [last [lindex $cgidata 1]]
                    set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"
                    set Offset 0
                }
                OFFSET     {set Offset [last [lindex $cgidata 1]]}
                SLAVE      {set Slave [last [lindex $cgidata 1]]}
                SDATA      {set SData  [last [lindex $cgidata 1]]}

                MODULE     {set ::R3B::R3B4K $vl}

                EXPERT   {do_expert $vl  [third [lindex $cgidata 1]]}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

