# Note:  This is loaded into the namespace  ASIC
# variable started 0

if {![info exists started]} {variable started 0 }

if {$started != 0} {
    variable JS ""
    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    variable JS ""
    
    proc do_redisplay {} {;}
    
    proc do_AnalyseSpectra { SIDE ASIC CHANNEL } {
	
	set file_name "E.$SIDE.$ASIC.$CHANNEL"
	# InsertLog "$file_name"
	
	# set SpecNames [SpectrumNames]
	# SpectrumNames is a function of Html/RunControl/sys.tcl 
	# I do not understand how it can be called here.
	# In fact I do not have any include of Html/RunControl/sys.tcl.
	
	set SpecDetails [SpectrumDetails $file_name]
	# SpecDetails has lenght 6.
	# The third element is the range : [0, x-max].
	set range [lindex $SpecDetails 2]
	set data [SpectrumRead1D $file_name 0 $range]
	# InsertLog "Range $range , $data"
	
	return [list $range $data] 
    }
    
    proc do_Analyze { params } {
	
	# set name [lindex [lindex $params 1] 0]
	set side_under_test [lindex [lindex $params 1] 1]
	set asic_under_test [lindex [lindex $params 1] 2] 
	
	# Set file name
	set file_name  /MIDAS/SpecData/R3B/TestData/
	append file_name [clock format [clock seconds] -format "%Y-%m-%d-"]
	append file_name "Source-"
	append file_name "Side$side_under_test-Asic$asic_under_test.txt"
	
	# Create file and set permissions.
	set flag_open [catch {open $file_name w} file_input]
	set flag_perm [catch {file attributes $file_name -permissions rwxrwxrwx} ]
	if { $flag_open != 0 } { InsertLog "Cannot open $file_name." }
	if { $flag_perm != 0 } { InsertLog "Error setting permission of $file_name." }
	
	# Loop over individual side.
	set side_number 2
        for {set itr_side 0} {$itr_side < $side_number} {incr itr_side} {
	    
	    if {$itr_side !=$side_under_test} {continue;}
	    
	    # Loop over individual asic.
	    set asic_number 16
	    for {set itr_asic 0} {$itr_asic < $asic_number} {incr itr_asic} {
		
		if {$itr_asic !=$asic_under_test} {continue;} 
		
		# Loop over individual channels.
		set channel_number 128
		for {set itr_ch 0} {$itr_ch < $channel_number} {incr itr_ch} {
		    
		    set plot [do_AnalyseSpectra $itr_side $itr_asic $itr_ch]
		    set range [lindex $plot 0]
		    set data  [lindex $plot 1]
		    
		    puts $file_input "$itr_side $itr_asic $itr_ch $range"
		    puts $file_input $data
		    flush $file_input
		}
	    }
	}
	
	close $file_input
	InsertLog "Analyze is complete"
    }
    
    proc do_Mask { params } {
	# set name [lindex [lindex $params 1] 0]
	set file_input [lindex [lindex $params 1] 1]
	
	# Set file name
	set file_name  /MIDAS/SpecData/R3B/Masking/
	append file_name "$file_input"
 	
	set f [open $file_name]
	while {[gets $f  line] >= 0} {
	    set side_mask    [lindex $line 0]
	    set asic_mask    [lindex $line 1]
	    set channel_mask [lindex $line 2]
	    
	    set REGISTER_pwr [expr 80 + ($channel_mask/8)]
	    set value_pwr [ReadR3BASICRegister [expr ($side_mask << 18) + ($asic_mask << 10) +  $REGISTER_pwr]]
	    set value_mask [expr pow (2, $channel_mask - ($channel_mask/8)*8 ) ]
	    set value_pwr [expr $value_pwr | int($value_mask) ]
	    
	    WriteR3BASICRegister [expr ($side_mask << 18) + ($asic_mask << 10) + $REGISTER_pwr] $value_pwr
	}
	close $f
	
	InsertLog "Masking completed."
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag
	
	set cgidata [ncgi::nvlist]
	
	InsertLog "cgidata= ([llength $cgidata]) $cgidata"
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		
		switch -glob $w {
		    
		    ANALYZE {do_Analyze $cgidata}
		    MASK    {do_Mask $cgidata}
		    RESET   { set started 0; }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}

