
#    Note:  This is loaded into the namespace  R3B

#variable started 0


if {![info exists started]} {variable started 0}

    variable JS ""

    global MIDAS_XR3BAccessServer_Exists
    if {[info exists MIDAS_XR3BAccessServer_Exists]} {
      set ::R3B::R3B4K "undefined"
      set z [catch {WriteR3BRegister 0x002 0x0000} m]
      selectmodule [exec uname -n]
    } else {
      set ::R3B::R3B4K [first $::R3B::ModuleMenu]
    }

if {$started != 0} {

#     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

#    variable JS ""
    variable HelpTopic "undefined"

    variable allmodules 0


   proc  show_variables {} {
      global NumSIDE
      global ModID0 ModID1
      global NumASICSperSIDE
      global SIDEList
      global ASICList0 ASICList1
      global SIDE
      global ASIC
      global MIDAS_XR3BAccessServer_Exists

    if {[info exists MIDAS_XR3BAccessServer_Exists]} {
         InsertLog "MIDAS_XR3BAccessServer_Exists = $MIDAS_XR3BAccessServer_Exists"
    }

     InsertLog "module = $::R3B::R3B4K"

      set BAK $::R3B::R3B4K  ;# save	

#      foreach R3B4K $::R3B::ModuleMenu {

       set R3B4K  [first $::R3B::ModuleMenu]

          selectmodule $R3B4K

          InsertLog "module = $::R3B::R3B4K"

          InsertLog "ModID 0 = $ModID0;  ModID 1 = $ModID1"

          InsertLog "NumSIDE = $NumSIDE"
          InsertLog "NumASICSperSIDE = $NumASICSperSIDE"
          InsertLog "SIDEs = $SIDEList"
          InsertLog "ASICs 0 = $ASICList0"
          InsertLog "ASICs 1 = $ASICList1"

          InsertLog "SIDE = $SIDE; ASIC = $ASIC"

#      }

#      selectmodule $BAK

          InsertLog "ModID 0 = $ModID0;  ModID 1 = $ModID1"

   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingR3BDataAcqAtGSI}

          default {}
       }

       do_help
   }

   proc probe_i2c {} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIDE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC

      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      set testdata 0xa5

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          do_ASICReset
          InsertLog "generated ASIC reset for module $R3B4K"

    set SIDEList {0 1}
    set ASICList0 {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
    set ASICList1 {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}

          foreach SIDE [set SIDEList] {

             set ASICList {}


             foreach ASIC [set ASICList$SIDE] {
                set i 0
                set z [catch {WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $testdata} m]
                if {$z != 0} {puts "1:SIDE $SIDE; ASIC $ASIC; Write register $i $testdata returned $m"}
                set z [catch {ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]} m]
                if {$z != 0} {puts "2:SIDE $SIDE; ASIC $ASIC; Read register $i returned $m"}
                set vl $m
                if {$vl != $testdata} {puts "3:SIDE $SIDE; ASIC $ASIC; Reg 0 $vl != $testdata"} else {lappend ASICList $ASIC}
                set z [catch {WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] 0} m]
                if {$z != 0} {puts "4:SIDE $SIDE; ASIC $ASIC; Write register $i 0 returned $m"}
             }

             if {[set ASICList] == {}} {
                set ASIC "-"
                InsertLog "$::R3B::R3B4K  -  SIDE $SIDE not present or empty"
                set SIDE "-"
             } else {
                set ASIC [first [set ASICList]]
                lappend SIDEList $SIDE
                InsertLog "$::R3B::R3B4K  -  SIDE $SIDE: ASICs discovered [set ASICList]"
             }
          }

      }

      selectmodule $BAK     ;#   restore

   }

   proc ASICReset {} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          do_ASICReset
          puts "generated ASIC reset for module $R3B4K"
          InsertLog "NOTE:  it is essential that a readout calibration is now performed - use SETUP"

      }

      selectmodule $BAK     ;#   restore

   }

   proc do_expert {cmd} {

       switch $cmd {
          I2CASIC            {probe_i2c}
          ASICRESET          {ASICReset}
          I2CDIAG            {InsertLog "Coming soon"}
          R3BDIAG            {InsertLog "Coming soon"}
          default {}
       }
   }


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

    selectmodule [first $::R3B::ModuleMenu]

}   ;# end of if {$started == 0}




