
#    Note:  This is loaded into the namespace  TIMES

# variable started 0

if {![info exists started]} {variable started 0}

  global Options

    if {![info exists Options(R3B_Fpga_ts_reg)]} {set Options(R3B_Fpga_ts_reg) 1000}
    if {![info exists Options(R3B_Asic_ts_PulseWidth)]} {set Options(R3B_Asic_ts_PulseWidth) 8}

if {$started != 0} {

     variable JS ""
     variable INFO ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable INFO ""

    variable allmodules 0

    for {set i 0} {$i <= 1} {incr i} {variable Opt1000.$i 0}

#   proc selectmodule {vl} {set ::R3B::R3B4K $vl}

   proc  show_variables {} {
       variable allmodules 

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules"

       for {set i 0} {$i <= 0} {incr i} {variable Opt1000.$i; InsertLog "1000.$i = [set Opt1000.$i]"}
   }

   proc do_redisplay {} {

     for {set i 0} {$i <= 1} {incr i} {
        variable Opt1000.$i
        set Opt1000.$i [ReadR3BRegister [expr 0x400 + $i]]
     }

     if {[expr [set Opt1000.1] & 48] == 0} {InsertLog "WARNING: DCM not locked - status = [set Opt1000.1]"}
   }

   proc do_setOpt1000 {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          switch $i {
              0   {WriteR3BRegister [expr 0x400 + $i] $vl}
              1   {InsertLog "coming - use first in list for now"}
              2   {InsertLog "coming - use first in list for now"}
              3   {InsertLog "coming - use first in list for now"}
              4   {InsertLog "coming - use first in list for now"}
              5   {InsertLog "coming - use first in list for now"}
              6   {InsertLog "coming - use first in list for now"}
              7   {InsertLog "coming - use first in list for now"}
              default {InsertLog "unexpected!!!"}
          }
      }

      selectmodule $BAK  ;#  restore
   }

   proc do_expert {cmd} {

       switch $cmd {

          ResetTimeStamp {do_ResetTimeStamp}
          SetExternalClock {do_SetExternalClock}
          SetInternalClock {do_SetInternalClock}
          EnableExtTrig1 {do_SetExtTrig 1 1}
          DisableExtTrig1 {do_SetExtTrig 1 0}
          EnableExtTrig0 {do_SetExtTrig 0 1}
          DisableExtTrig0 {do_SetExtTrig 0 0}
          default {}
       }
   }

   proc do_SetExtTrig {w vl} {
      global env
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          set R0x400 [ReadR3BRegister 0x400]   ;# read and save

          if {$w == 0 && $vl == 0} {
              WriteR3BRegister 0x400  [expr ($R0x400 & 0xfffeffff) | 0x00000]    ;#  disable external trigger #0
          }
          if {$w == 0 && $vl == 1} {
              WriteR3BRegister 0x400  [expr ($R0x400 & 0xfffeffff) | 0x10000]    ;#  enable external trigger #0
          }
          if {$w == 1 && $vl == 0} {
              WriteR3BRegister 0x400  [expr ($R0x400 & 0xfffdffff) | 0x00000]    ;#  disable external trigger #1
          }
          if {$w == 1 && $vl == 1} {
              WriteR3BRegister 0x400  [expr ($R0x400 & 0xfffdffff) | 0x20000]    ;#  enable external trigger #1
          }

      }

      InsertLog "External Trigger mode now set"

      selectmodule $BAK  ;#  restore

  }

   proc do_ResetTimeStamp {} {
       global Options
       global SIDEList
       global ASICList0
       global ASICList1

          set reg [ReadR3BRegister 0x300]
          WriteR3BRegister 0x300  [expr ($reg & 0xfffffffe)]    ;# deassert Val_trig (bit 0)

          set reg [ReadR3BRegister 0x400]
          WriteR3BRegister 0x400  [expr ($reg & 0x0000ffff) | (($Options(Fpga_ts_reg) & 0x0000ffff) << 16)]    ;# set Fpga_ts_reg

          set reg [ReadR3BRegister 0x400]
          WriteR3BRegister 0x400  [expr ($reg & 0xfffff0fff) | (($Options(Asic_ts_pw)] & 15) << 12)]           ;# set Fpga_ts_reg


 	foreach side $SIDEList {
             foreach asic [set ASICList$side] {

              set i 1    ;#  REG1
              set reg [ReadR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i]]
              set vl [expr ($reg & 0xcf) | 0x30]                                             ;# VAL input not active
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] $vl
  	     }
          }    


          set reg [ReadR3BRegister 0x400]
          WriteR3BRegister 0x400  [expr ($reg & 0xffffffcf) | 0x10]    ;# connect ts_rst to asic_val


 	foreach side $SIDEList {
             foreach asic [set ASICList$side] {

              set i 1    ;#  REG1
              set reg [ReadR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i]]
              set vl [expr ($reg & 0xcf) | 0x20]                                             ;# Time Stamp Reset -> VAL input
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] $vl
  	     }
          }    


          set reg [ReadR3BRegister 0x400]
          WriteR3BRegister 0x400  [expr ($reg & 0xffffffcf)]    ;# connect cal_val to ASIC_val


 	foreach side $SIDEList {
             foreach asic [set ASICList$side] {

              set i 1    ;#  REG1
              set reg [ReadR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i]]
              set vl [expr ($reg & 0xcf) | 0x30]                                             ;# VAL input not active
              WriteR3BASICRegister [expr ($side << 18) + ($asic << 10) + $i] $vl  

             }
          }        

          InsertLog "Time Stamp Reset complete  DCM status [ReadR3BRegister [expr 0x400 + 1]]"

   }


   proc do_SetExternalClock {} {
      global env
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

#    set clock source via CBS to external

          switch [exec /bin/uname -p] {
             ppc {
                set z [catch {exec [file join $env(MIDASBASE) R3B CBS cbs.exe] -x -c} m]
                if {$z != 0} {InsertLog "$m"}              
             }
             default {
                 InsertLog "not available for this processor"
             }
          }

#    PLL disable   (to be confirmed)

#    Clk_sel to external 

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 | 2]
          WriteR3BRegister 0x400 $reg0

#    reset custom DCM

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 | 1]   ;#  reset
          WriteR3BRegister 0x400 $reg0
          set reg0 [expr $reg0 & 0xfffffffe]    ;#   not reset
          WriteR3BRegister 0x400 $reg0

      }

      InsertLog "Clock source now set to external"

     selectmodule $BAK  ;#  restore

   }

   proc do_SetInternalClock {} {
      global env 
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

#    set clock source via CBS to internal

         switch [exec /bin/uname -p] {
              ppc {
                 set z [catch {exec [file join $env(MIDASBASE) R3B CBS cbs.exe] -i -c} m]
                 if {$z != 0} {InsertLog "$m"}
              }
              default {
                 InsertLog "not available for this processor"
              }
          }

#    PLL enable

          switch [exec /bin/uname -p] {
              ppc {
                 set z [catch {exec [file join $env(MIDASBASE) R3B PLL pll.exe] -s 0xe8 0x00 0x00 0x0a 0x20 0x01} m]
                 if {$z != 0} {InsertLog "$m"}
              }
              default {
                 InsertLog "not available for this processor"
              }
          }

#    Clk_sel to internal 

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 & 0xfffffffd]
          WriteR3BRegister 0x400 $reg0

#    reset custom DCM

          set reg0 [ReadR3BRegister 0x400]
          set reg0 [expr $reg0 | 1]   ;#  reset
          WriteR3BRegister 0x400 $reg0
          set reg0 [expr $reg0 & 0xfffffffe]    ;#   not reset
          WriteR3BRegister 0x400 $reg0
      }

      InsertLog "Clock source now set to internal"

      selectmodule $BAK  ;#  restore

   }
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS1000     {do_setOpt1000 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }
     do_redisplay

}   ;# end of if {$started == 0}




