
#    Note:  This is loaded into the namespace  UASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable HelpTopic "R3B"

    variable CH 0

    variable allmodules 0
    variable allasics 0
    variable allsides 0
    variable allchs 0

    variable SCHAN 0
    variable STATSIDE 0
    variable STATASIC 0
    variable STATCHAN 0
    
#    ASIC parameters

     variable EnergyThresholdList {128 136 144 152 160 168 176 184 192 200 208 216 224 232 240 248 255}
     variable EnergyThresholdIDs  {"128 0x80" "136 0x88" "144 0x90" "152 0x98" "160 0xa0" "168 0xa8" "176 0xb0" \
           "184 0xb8" "192 0xc0" "200 0xc8" "208 0xd0" "216 0xd8" "224 0xe0" "232 0xe8" "240 0xf0" "248 0xf8" "255 0xff"}

     variable ChargeCarrier 0
     variable Neighbours 0
     variable ResetDelay 0
     variable TriggerLength 1
     variable ShapingTime 1
     variable DelayAfterPeak 0
     variable EnergyThreshold 0
     
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc  show_variables {} {
       variable allmodules
       variable allasics
       variable allsides
     variable ChargeCarrier
     variable Neighbours
     variable ResetDelay
     variable TriggerLength
     variable ShapingTime
     variable DelayAfterPeak
     variable EnergyThreshold

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules; all sides = $allsides; all asics = $allasics"
       InsertLog "Charge Carrier = $ChargeCarrier"
       InsertLog "Neighbours = $Neighbours"
       InsertLog "ResetDelay = $ResetDelay"
       InsertLog "TriggerLength = $TriggerLength"
       InsertLog "Shaping Time = $ShapingTime"
       InsertLog "Delay After Peak = $DelayAfterPeak"
       InsertLog "Energy Threshold = $EnergyThreshold"

   }

   proc do_redisplay {} {
     global SIDE ASIC
     variable ChargeCarrier
     variable Neighbours
     variable ResetDelay
     variable TriggerLength
     variable ShapingTime
     variable DelayAfterPeak
     variable EnergyThreshold
      
      set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1]]

      set ChargeCarrier [expr ($vl >> 7) & 1]
      set Neighbours [expr ($vl >> 6) & 1]
      
      set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 3]]
      set ResetDelay [expr ($vl >> 4) & 15]
      set TriggerLength [expr $vl & 15]
      
      set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 4]]
      set ShapingTime [expr ($vl >> 4) & 15]
      set DelayAfterPeak [expr $vl & 15]
      
      set vl [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 15]]
      set EnergyThreshold $vl

   }

   proc do_SetASICReg {reg vl} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC
     variable allasics
     variable allsides
     variable allmodules
     variable ChargeCarrier
     variable Neighbours
     variable ResetDelay
     variable TriggerLength
     variable ShapingTime
     variable DelayAfterPeak
     variable EnergyThreshold

     set ABAK $ASIC
     set SBAK $SIDE

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

     foreach SIDE $SIDEList {
        if {$allsides == 0 && $SIDE != $SBAK} continue
     
     foreach ASIC [set ASICList$SIDE] {
        if {$allasics == 0 && $ASIC != $ABAK} continue

       set ValMode [expr [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1]] & 0x30]
     
       switch $reg {
          Neighbour_Mode   {set Neighbours $vl; WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 1] [expr ($ChargeCarrier << 7) + ($Neighbours << 6) + $ValMode]}
          Reset_Delay      {set ResetDelay $vl; WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 3] [expr ($ResetDelay << 4) + $TriggerLength]}
          Trigger_Length   {set TriggerLength $vl; WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 3] [expr ($ResetDelay << 4) + $TriggerLength]}
          Shaping_Time     {set ShapingTime $vl; WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 4] [expr ($ShapingTime << 4) + $DelayAfterPeak]}
          Delay_after_Peak {set DelayAfterPeak $vl; WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 4] [expr ($ShapingTime << 4) + $DelayAfterPeak]}
          Energy_Threshold {set EnergyThreshold $vl; WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 15] $EnergyThreshold}
       }
     }

     }

     }
     
      selectmodule $BAK   ;#  restore
     set ASIC $ABAK
     set SIDE $SBAK
   }

   proc do_CHEnable {vl} {
       global NumSide
       global ModID0 ModID1
       global NumASICSperSIZE
       global SIDEList
       global ASICList0 ASICList1
       global SIDE
       global ASIC
     variable allasics
     variable allsides
     variable allchs
     variable allmodules
     variable CH

     set ABAK $ASIC
     set SBAK $SIDE
     set CBAK $CH

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

     foreach SIDE $SIDEList {
        if {$allsides == 0 && $SIDE != $SBAK} continue
     
        foreach ASIC [set ASICList$SIDE] {
           if {$allasics == 0 && $ASIC != $ABAK} continue

           for {set CH 0} {$CH <= 127} {incr CH}  {
              if {$allchs == 0 && $CH != $CBAK} continue

                 set Reg [expr $CH / 8]
                 set RegVlA [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 80 + $Reg]]

                 set offset [expr $CH - ($Reg * 8)]
                 set RegVlB [expr ($RegVlA & ~(1 << $offset)) + ($vl << $offset)]

                 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + 80 + $Reg] $RegVlB

#InsertLog "$SIDE $ASIC $CH $Reg $RegVlA $offset [format 0x%x [expr ~(1 << $offset)]]"
#InsertLog "[expr ($RegVlA & !(1 << $offset))] [expr ($vl << $offset)]  [format 0x%x $RegVlB]"

                 InsertLog "Side $SIDE; ASIC $ASIC; Channel $CH; [format 0x%x $RegVlA] => [format 0x%x $RegVlB]"
     
           }
        }
     }

     }
     
     set selectmodule $BAK

     set CH $CBAK
     set ASIC $ABAK
     set SIDE $SBAK
   }

   proc do_CHAN {vl} {
     variable STATSIDE
     variable STATASIC
     variable STATCHAN

     set chan $vl
     if {$chan < 4096} {} else {set chan [expr $chan - 4096]} 
     if {$chan < 2048} {set STATSIDE 0} else {set STATSIDE 1; set chan [expr $chan - 2048]}
     set STATASIC [expr $chan / 128]
     set STATCHAN [expr $chan - ($STATASIC*128)]
   }


   proc do_expert {cmd} {
       variable ValCount

       switch $cmd {

          default {}
       }
   }

   proc selectmodule {vl} {::R3B::selectmodule $vl}
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable HelpTopic

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]
              set p [third [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   
                   HELP     {
                       switch $vl {
                          UASIC   {set HelpTopic "UASIC"}
                          default {set HelpTopic "R3B"}
                       }
                       do_help
                   }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   
                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLASICS   {variable allasics; set allasics [expr ($allasics + 1) & 1]}
                   ALLSIDES   {variable allsides; set allsides [expr ($allsides + 1) & 1]}
                   ALLCHS     {variable allchs; set allchs [expr ($allchs + 1) & 1]}

                   CHENABLE   {do_CHEnable 0}
                   CHDISABLE  {do_CHEnable 1}
                   
                   ASIC     {global ASIC; set ASIC $vl; do_redisplay}
                   SIDE     {global SIDE; set SIDE $vl; do_redisplay}
                   CH       {variable CH; set CH $vl}

                   CHAN     {variable SCHAN; set SCHAN $vl; do_CHAN $vl}
                   
                   EXPERT   {do_expert $vl}
                   
                   ASICREG  {do_SetASICReg $vl $p}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }
     do_redisplay

}   ;# end of if {$started == 0}




