
#    MIDAS Access Server  for XR3BASIC 


package require MIDASDomainHandler     ;#  load default support procedures

 set z [catch {package require XR3BASICAccess} m]
 if {$z != 0} {puts $m}

global MIDAS_XR3BASICAccessServer_Exists
set MIDAS_XR3BASICAccessServer_Exists 0

global MIDAS_XR3BASICAccessServer_Verbose
set MIDAS_XR3BASICAccessServer_Verbose 0

global R3BASICErr1
if {![info exists R3BASICErr1]} {set R3BASICErr1 0}

global R3BASICBase
if {![info exists R3BASICBase]} {set R3BASICBase 16}

global R3BASICTestMode
if {![info exists R3BASICTestMode]} {set R3BASICTestMode 0}


# Use namespaces to isolate our methods
namespace eval urn:XR3BASICAccessServer {

    proc AccessServerVerbose {option} {
        do_AccessServerVerbose $option
        return [rpcvar::rpcvar int 0]
    }

    proc Set {Address Value} {
        do_Set $Address $Value
        return [rpcvar::rpcvar int 0]
    }

    proc Get {Address} {
        set vl [do_Get $Address]
        return [rpcvar::rpcvar int $vl]
    }

    proc do_AccessServerVerbose {option} {
        global MIDAS_XR3BASICAccessServer_Verbose
        if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "called method AccessServerVerbose with parameter $option"}
        set MIDAS_XR3BASICAccessServer_Verbose $option
        XR3BASICAccess_Verbose $option
    }

    proc do_Set {Address Value} {
       global MIDAS_XR3BASICAccessServer_Verbose
       global R3BASICErr1
       global R3BASICBase
       global R3BASICTestMode

       if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "XR3BASIC: do_Set $Address ([format "0x%x" $Address]) = $Value"}

       if {$R3BASICTestMode != 0} {return 0}

        set Offset [expr ($Address & 255)]
        set Page [expr ($Address >> 8) & 3]
        set ASIC [expr $R3BASICBase + (($Address >> 10) & 255)]
        if {$R3BASICErr1 == 1} {set ASIC [expr 15-$ASIC]}
        set BUS [expr ($Address >> 18) & 255]

       if {$Offset >= 128} {
          set z [catch {XR3BASICAccess_Set -c [expr $ASIC + ($BUS << 8)] -a 0 -v [expr (1 << $Page)]} m]
       }
       set z [catch {XR3BASICAccess_Set -c [expr $ASIC + ($BUS << 8)] -a $Offset -v $Value} m]

       if {$z == 0} then {
          if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "XR3BASIC: do_Set $BUS $ASIC $Page ([format "0x%x" $Address]) = $Value"}
          return 0
       } else {
          if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "XR3BASIC: do_Set rc=$z ($m) $Address ([format "0x%x" $Address]) = $Value"}
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Get {Address} {
       global MIDAS_XR3BASICAccessServer_Verbose
       global R3BASICErr1
       global R3BASICBase
       global R3BASICTestMode

       if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "XR3BASIC: do_Get $Address ([format "0x%x" $Address])"}

       if {$R3BASICTestMode != 0} {return "1 0x0"}

        set Offset [expr ($Address & 255)]
        set Page [expr ($Address >> 8) & 3]
        set ASIC [expr $R3BASICBase + (($Address >> 10) & 255)]
        if {$R3BASICErr1 == 1} {set ASIC [expr 15-$ASIC]}
        set BUS [expr ($Address >> 18) & 255]

       if {$Offset >= 128} {
          set z [catch {XR3BASICAccess_Set -c [expr $ASIC + ($BUS << 8)] -a 0 -v [expr (1 << $Page)]} m]
       }
       set z [catch {XR3BASICAccess_Get -c [expr $ASIC + ($BUS << 8)] -a $Offset} m]

       if {$z == 0} then {
          if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "XR3BASIC: do_Get  $BUS $ASIC $Page $Address ([format "0x%x" $Address]) = $m"}
          return $m
       } else {
           if {$MIDAS_XR3BASICAccessServer_Verbose} {puts "XR3BASIC: do_Get rc=$z ($m) $Address ([format "0x%x" $Address])"}
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export Set
     SOAP::export Get
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /XR3BASICAccessServer  -namespace urn:XR3BASICAccessServer -uri urn:XR3BASICAccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/XR3BASICAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide XR3BASICAccessServer 1.0
