
#    MIDAS Access Server  for XR3B 


package require MIDASDomainHandler     ;#  load default support procedures

set z [catch {package require XR3BAccess} m]
if {$z != 0} {puts $m}


global MIDAS_XR3BAccessServer_Exists
set MIDAS_XR3BAccessServer_Exists 0

global MIDAS_XR3BAccessServer_Verbose
set MIDAS_XR3BAccessServer_Verbose 0


global R3BTestMode
if {![info exists R3BTestMode]} {set R3BTestMode 0}


# Use namespaces to isolate our methods
namespace eval urn:XR3BAccessServer {

    proc AccessServerVerbose {option} {
        do_AccessServerVerbose $option
        return [rpcvar::rpcvar int 0]
    }

    proc Set {Address Value} {
        do_Set $Address $Value
        return [rpcvar::rpcvar int 0]
    }

    proc Get {Address} {
        set vl [do_Get $Address]
        return [rpcvar::rpcvar int $vl]
    }

    proc do_AccessServerVerbose {option} {
        global MIDAS_XR3BAccessServer_Verbose
        if {$MIDAS_XR3BAccessServer_Verbose} {puts "called method AccessServerVerbose with parameter $option"}
        set MIDAS_XR3BAccessServer_Verbose $option
        XR3BAccess_Verbose $option
    }

    proc do_Set {Address Value} {
       global MIDAS_XR3BAccessServer_Verbose
       global R3BTestMode

       if {$MIDAS_XR3BAccessServer_Verbose} {puts "XR3B: do_Set $Address ([format "0x%x" $Address]) = $Value"}

       if {$R3BTestMode != 0} {return 0}

       set z [catch {XR3BAccess_Set -a $Address -d $Value} m]

       if {$z == 0} then {
          return 0
       } else {
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }

    proc do_Get {Address} {
       global MIDAS_XR3BAccessServer_Verbose
       global R3BTestMode
       global env

       if {$MIDAS_XR3BAccessServer_Verbose} {puts "XR3B: do_Get $Address ([format "0x%x" $Address])"}

       if {$R3BTestMode != 0} {return "0x0"}

       switch -glob $Address {
          0x00008000    {
              set z [catch {exec [file join $env(MIDASBASE) R3B pt100 ReadTemp readtemp.exe] -r} m]
          }
          0x00008001    {
              set z [catch {exec [file join $env(MIDASBASE) R3B pt100 ReadTemp readtemp.exe] -c} m]
          }
          default {
              set z [catch {XR3BAccess_Get -a $Address} m]
          }
       }

       if {$z == 0} then {
          if {$MIDAS_XR3BAccessServer_Verbose} {puts "XR3B: do_Get $Address ([format "0x%x" $Address]) = $m"}
          return $m
       } else {
           if {$MIDAS_XR3BAccessServer_Verbose} {puts "XR3B: do_Get rc=$z ($m) $Address ([format "0x%x" $Address])"}
           return -code error -errorcode 0x10005 -errorinfo "received error response: rc=$z\n  $m"
       }
    }


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export Set
     SOAP::export Get
}

# register this service with tclhttpd
puts [SOAP::Domain::register  -prefix  /XR3BAccessServer  -namespace urn:XR3BAccessServer -uri urn:XR3BAccessServer]


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/XR3BAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide XR3BAccessServer 1.0
